Missing exit
[libdcp.git] / run / tests
1 #!/bin/bash
2 #
3 # Run our test suite.
4
5 # Private test data; this is stuff that is non-distributable
6 private=../libdcp1-test-private
7 # Work directory
8 work=build/test
9 # Path to dcpinfo tool
10 dcpinfo=build/tools/dcpinfo
11
12 export LD_LIBRARY_PATH=build/src:build/asdcplib/src:$LD_LIBRARY_PATH
13
14 # Make sure we have the required tools
15 for c in xmlsec1 xmldiff; do
16   hash $c 2>/dev/null || { echo >&2 "$c required but not found; aborting"; exit 1; }
17 done
18
19 # Run the unit tests in test/
20 if [ "$1" == "--debug" ]; then
21     shift
22     gdb --args $work/tests $private
23 elif [ "$1" == "--valgrind" ]; then
24     shift
25     valgrind --tool="memcheck" $work/tests $private
26 elif [ "$1" == "--callgrind" ]; then
27     shift
28     valgrind --tool="callgrind" $work/tests $private $*
29 else
30     $work/tests $private $*
31     if [ "$?" != "0" ]; then
32         echo "FAIL: unit tests"
33         exit 1
34     fi
35 fi
36
37 # Check a MXF written by the unit tests
38 diff $work/baz/video1.mxf $work/baz/video2.mxf
39 if [ "$?" != "0" ]; then
40     echo "FAIL: MXFs from recovery incorrect"
41     exit 1
42 fi
43
44 # Check the DCP written by dcp_test1
45 diff -ur test/ref/DCP/dcp_test1 $work/DCP/dcp_test1
46 if [ "$?" != "0" ]; then
47     echo "FAIL: files differ"
48     exit 1
49 fi
50
51 # Check the DCP written by dcp_test2
52 diff -ur test/ref/DCP/dcp_test2 $work/DCP/dcp_test2
53 if [ "$?" != "0" ]; then
54     echo "FAIL: files differ"
55     exit 1
56 fi
57
58 # Check the DCP written by dcp_test5
59 diff -ur test/ref/DCP/dcp_test5 $work/DCP/dcp_test5
60 if [ "$?" != "0" ]; then
61     echo "FAIL: files differ"
62     exit 1
63 fi
64
65 # Check the DCP written by encryption_test
66 diff -ur test/ref/DCP/encryption_test $work/DCP/encryption_test
67 if [ "$?" != "0" ]; then
68     echo "FAIL: files differ"
69     exit 1
70 fi
71
72 # Everything beyond this point needs $private to exist
73 if [ ! -e "$private/info.log" ]; then
74     echo ""
75     echo "Private data not found: some tests will not run."
76     exit 1
77 fi
78
79 # Run dcpinfo on all the DCPs in private/metadata, writing $work/info.log
80 # This writes details of the CPLs and all subtitle details, so it checks
81 # if the code is reading subtitle files correctly.
82 rm -f $work/info.log
83 for d in `find $private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
84     if [ `basename $d` != ".git" ]; then
85         $dcpinfo --ignore-missing-assets -k -s $d >> $work/info.log
86         if [ "$?" != "0" ]; then
87             echo "FAIL: dcpinfo failed for $d"
88             exit 1
89         fi
90     fi
91 done
92
93 # Check info.log is what it should be
94 diff -q $work/info.log $private/info.log
95 if [ "$?" != "0" ]; then
96     echo "FAIL: dcpinfo output incorrect"
97     exit 1
98 fi
99
100 # Copy $private into build/ then re-write the subtitles of every DCP using
101 # $work/rewrite_subs.  This tests round-trip of subtitle reading/writing.
102 # Note that all the subs in $private/metadata are Interop.
103 rm -f $work/info2.log
104 rm -rf $work/private
105 mkdir $work/private
106 cp -r $private/* $work/private
107 for d in `find $work/private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
108     if [ `basename $d` != ".git" ]; then
109         $work/rewrite_subs $d
110         $dcpinfo --ignore-missing-assets -k -s $d >> $work/info2.log
111     fi
112 done
113
114 # Fudge the output
115 sed -i "s/DCP: build\/test/DCP: test/g" $work/info2.log
116
117 # And check it
118 diff -q $work/info2.log $private/info2.log
119 if [ "$?" != "0" ]; then
120     echo "FAIL: dcpinfo output from rewrite incorrect"
121     exit 1
122 fi
123
124 # Dump the subs of JourneyToJah... (which has MXF-wrapped SMPTE subtitles)
125 # and check that they are right
126 $dcpinfo -s $private/data/JourneyToJah_TLR-1_F_EN-DE-FR_CH_51_2K_LOK_20140225_DGL_SMPTE_OV >> $work/jah.log
127
128 # Parse some problematic subs and check that we get it right
129 run/test/subs_in_out $private/TunaBoat_Icelandic_Reel1_V1_8sec.xml > $work/tuna.xml
130 diff -q $private/TunaBoat_Icelandic_Reel1_V1_8sec.parsed.xml $work/tuna.xml
131 if [ "$?" != "0" ]; then
132     echo "FAIL: output of parse check 1 invalid"
133     exit 1
134 fi
135
136 echo "PASS"